AOZ Studio Beta - Bug #882

For loop fails if Step is set using hex or a binary *constant*
12/25/2021 03:59 AM - Brian Flanagan

Status: Resolved Start date: 12/24/2021
Priority: Normal Due date:

Assignee: AQOZ Developers % Done: 0%
Category: Estimated time: 0:00 hour
Target version: none

Affected version: 1.0.0 (B12) u19

Description

| can use a variable without a problem. | can also use a decimal constant.
If, however, | use a binary or hex constant, the For loop will continue past the limit.
For example:

This works:

gbStart=$E1E1l

gbEnd=S$FFFF

gbStep=5$202

For gb=gbStart To gbEnd Step gbStep
Locate 0,0 : Print Hex$ (gb,6);
Print Using "-—-##########";gb
Wait Key

Next gb

This will also work:

gbStart=$E1E1

gbEnd=S$FFFF

gbStep=$202

For gb=gbStart To gbEnd Step 514
Locate 0,0 : Print Hex$ (gb, 6);
Print Using "-#########%";gb
Wait Key

Next gb

This will NOT work:

gbStart=SE1E1l

gbEnd=$FFFF

gbStep=$202

For gb=gbStart To gbEnd Step $202
Locate 0,0 : Print Hex$(gb,6);
Print Using "-##########";gb
Wait Key

Next gb

This also will NOT work:

gbStart=$E1E1l

gbEnd=SFFFF

gbStep=$202

For gb=gbStart To gbEnd Step %001000000010
Locate 0,0 : Print Hex$ (gb,6);
Print Using "-##########";9b
Wait Key

Next gb
#1 - 01/20/2022 08:45 PM - David Baldwin
Why would you do that Brian? ;)

#2 - 02/13/2022 06:57 PM - David Baldwin

- Status changed from New to Resolved

#3 - 02/17/2022 08:04 AM - Brian Flanagan
- Status changed from Resolved to Feedback

- Affected version changed from 1.0.0 (B11) u17 to 1.0.0 (B12) u19

Still fails. (re-tested in newest 1.0.0 (B12) u19 version (as of 2/16/2022)

Loop still continues beyond the limit.
Here's another example:

gbStart=$E1E1l
gbEnd=$FFFF
gbStep=$202
Print Using "Start: —-#########4";gbStart
Print Using "End: —###HHEHEHE"; gbENd
For gb=gbStart To gbEnd Step $202
Locate 0,3
Print Hex$ (gb, 6);
Print Using "—#######4##";gb;
If gb > gbEnd Then Locate 20,1 : Print Using "< —##########";9gb
Wait 0.3
Next gb

Why? For some applications, it's easier to do things in Hex!

#4 - 06/29/2022 10:55 AM - Francois Lionet

- Status changed from Feedback to Resolved

Seems fixed!
